#include "storypresent.h"
#include "dag_layout.h"
#include "xast_parse.h"
#include "dag_present.h"
#include "cmp_present.h"
#include <argsparser.h>
#include "storypresent.h"
#include <QDebug>
#include <QMessageBox>
#include <QTextEdit>
#include <QtWidgets/QApplication>


using namespace args_parse;
using namespace std;


int main(int argc, char* argv[]) {
	QApplication a(argc, argv);

	ArgsParser cmdrec;
	auto help_mode = std::make_shared<MatchMode>(0x000au, u8"ӡĵ");
	cmdrec << help_mode;
	(*help_mode) << std::make_shared<IndexParam>(u8"StoryPresent", u8"") << make_shared<FloatOption>(u8"help", u8"ӡĵ");

	auto test_mode = std::make_shared<MatchMode>(0x000bu, u8"ڲ");
	cmdrec << test_mode;
	(*test_mode) << std::make_shared<IndexParam>(u8"StoryPresent", u8"") << make_shared<FloatOption>(u8"test", u8"ڲѡ");

	auto graph_mode = std::make_shared<MatchMode>(0x000cu, u8"ͼλչʾ");
	cmdrec << graph_mode;
	(*graph_mode) << std::make_shared<IndexParam>(u8"StoryPresent", u8"")
		<< make_shared<FloatKeyValue>(u8"graph", u8"ڲѡдdagudg")
		<< make_shared<FloatKeyValue>(u8"path", u8"ָxastļ·");

	auto rst = cmdrec.parse(argc, argv);
	QTextEdit msg;
	msg.setReadOnly(true);
	if (!rst) {
		msg.setWindowTitle(u8"");
		msg.setPlainText(cmdrec.helperDoc());
		msg.show();
	}
	else {
		switch (rst->modeCode()) {
		case 0x000au:
			msg.setWindowTitle(u8"Ϣ");
			msg.setPlainText(cmdrec.helperDoc());
			msg.show();
			break;

		case 0x000bu:
			{
			}break;
		case 0x000cu:
			{
				auto type = rst->getUnitViaKey(u8"graph");
				auto path = rst->getUnitViaKey(u8"path");
				if (type->value().toString() == "dag") {
					auto view = new StoryPresent();
					view->loadXAST(path->value().toString());
					view->show();
				}
			}break;
		default:
			break;
		}
	}

	return a.exec();
}
